Index: main/java/org/drools/examples/sudoku/Main.java
===================================================================
--- main/java/org/drools/examples/sudoku/Main.java	(revision 23682)
+++ main/java/org/drools/examples/sudoku/Main.java	(working copy)
@@ -11,6 +11,9 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import java.io.IOException;
+import java.lang.reflect.Constructor;
+import java.lang.reflect.InvocationTargetException;
+import java.util.Iterator;
 
 import javax.swing.JButton;
 import javax.swing.JFileChooser;
@@ -21,11 +24,11 @@
 import javax.swing.JPanel;
 
 import org.drools.examples.sudoku.rules.DroolsSudokuGridModel;
-import org.drools.examples.sudoku.swing.SudokuGridSamples;
+import org.drools.examples.sudoku.swing.SudokuGridModelConstants;
 import org.drools.examples.sudoku.swing.SudokuGridView;
 
 /**
- * This example shows how Drools can be used to solve a 9x9 Sudoku Grid.
+ * This example shows how Drools can be used to solve a Sudoku Grid.
  * <p
  * This Class hooks together the GUI and the model and allows you to 
  * load different grids.
@@ -47,61 +50,115 @@
    private BorderLayout borderLayout = new BorderLayout();
    private FlowLayout flowLayout = new FlowLayout(FlowLayout.RIGHT);
    private JPanel buttonPanel = new JPanel(flowLayout);
-   private JButton solveButton = new JButton("Solve");
-   private JButton fireOneRuleButton = new JButton("Step");
+   private JButton solveButton = new JButton("Solve Grid");
+   private int numberOfSolvingPasses = 0;
    private JFileChooser fileChooser;
+   private JMenu gridMenu = new JMenu("Grid Size");
    
    public static void main(String[] args)
    {
-      @SuppressWarnings("unused")
-      Main main = new Main();
+	  Main main = new Main();
+	  main.run();
    }
    
    public Main()
    {
       mainFrame = new JFrame("Drools Sudoku Example");
-      for (String sampleName : SudokuGridSamples.getInstance().getSampleNames())
-      {
-         JMenuItem menuItem = new JMenuItem(sampleName);
-         menuItem.addActionListener(this);
-         samplesMenu.add(menuItem);
-      }
-      fileMenu.add(samplesMenu);
+
       openMenuItem.addActionListener(this);
-      // fileMenu.add(openMenuItem);
       exitMenuItem.addActionListener(this);
-      fileMenu.add(exitMenuItem);
-      menuBar.add(fileMenu);
+      setupGridSizeMenu();
+
+      setMenuBar();
       mainFrame.setJMenuBar(menuBar);
-      sudokuGridView = new SudokuGridView();
-      droolsSudokuGridModel = new DroolsSudokuGridModel(SudokuGridSamples.getInstance().getSample("Simple"));
       mainFrame.setLayout(borderLayout);
-      mainFrame.add(BorderLayout.CENTER, sudokuGridView);
-      // buttonPanel.add(fireOneRuleButton);
       buttonPanel.add(solveButton);
       solveButton.addActionListener(this);
       mainFrame.add(BorderLayout.SOUTH, buttonPanel);
       mainFrame.setSize(400,400);
       mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
-      mainFrame.setVisible(true);
-      sudokuGridView.setModel(droolsSudokuGridModel);
    }
 
+   private void clearMenuBar(){
+	      menuBar.remove(fileMenu);
+	      fileMenu = new JMenu("File");
+	   
+   }
+   
+private void setMenuBar() {
+	fileMenu.add(addSampleMenu());
+      fileMenu.add(gridMenu);
+      fileMenu.add(exitMenuItem);
+      menuBar.add(fileMenu);
+}
+
+private JMenu addSampleMenu() {
+	 Iterator<String> iter = SudokuGridModelConstants.getInstance().getSampleNames().iterator();
+	 samplesMenu = new JMenu("Samples");
+      while(iter.hasNext())
+      {
+         String sampleName = iter.next();
+         JMenuItem menuItem = new JMenuItem(sampleName);
+         menuItem.addActionListener(this);
+         samplesMenu.add(menuItem);
+      }
+      return samplesMenu;
+}
+
+private void setupGridSizeMenu()
+{
+	JMenuItem menuItem = new JMenuItem("4x4");
+    gridMenu.add(menuItem);
+    menuItem.addActionListener(this);
+    menuItem = new JMenuItem("6x6");
+    gridMenu.add(menuItem);
+    menuItem.addActionListener(this);
+    menuItem = new JMenuItem("9x9");
+    gridMenu.add(menuItem);
+    menuItem.addActionListener(this);
+}
+/**
+ * 
+ */
+private void run() {
+	  sudokuGridView = new SudokuGridView();
+      droolsSudokuGridModel = new DroolsSudokuGridModel(SudokuGridModelConstants.getInstance().getSample("Simple"));
+      sudokuGridView.setModel(droolsSudokuGridModel);
+      mainFrame.add(BorderLayout.CENTER, sudokuGridView);
+      mainFrame.setVisible(true);
+      }
+
    public void actionPerformed(ActionEvent ev)
    {
       if (ev.getSource().equals(solveButton))
       {
          long startTime = System.currentTimeMillis();
 
-         if (droolsSudokuGridModel.solve())
+         if ( numberOfSolvingPasses > 0)
          {
+             droolsSudokuGridModel.determineCellsByGuessing();        	 
+             droolsSudokuGridModel.solve();
+         }
+         else {
+             droolsSudokuGridModel.solve();        	 
+         }
+         numberOfSolvingPasses++;
+         
+         if ( droolsSudokuGridModel.isGridSolved())
+         {
             solveButton.setText("Solved ("+(System.currentTimeMillis()-startTime)+" ms)");
             solveButton.setEnabled(false);
          }
          else
          {
-            solveButton.setText("Unsolved ("+(System.currentTimeMillis()-startTime)+" ms)");
-            solveButton.setEnabled(false);            
+        	 if(droolsSudokuGridModel.isGridInError())
+        	 {
+        		 solveButton.setText("Not Solved ("+(System.currentTimeMillis()-startTime)+" ms)");
+                 solveButton.setEnabled(false);        		 
+        	 }
+        	 else{
+        		 solveButton.setText("Try guessing?");
+        	 }
          }
       }
       else if (ev.getSource().equals(openMenuItem))
@@ -129,15 +186,34 @@
       }
       else if (ev.getSource() instanceof JMenuItem)
       {
-         JMenuItem menuItem = (JMenuItem) ev.getSource();
-         droolsSudokuGridModel = new DroolsSudokuGridModel(SudokuGridSamples.getInstance().getSample(menuItem.getText()));
-         sudokuGridView.setModel(droolsSudokuGridModel);
+    	  JMenuItem menuItem = (JMenuItem) ev.getSource();
+    	  boolean sampleMatch = false;
+    		 Iterator<String> iter = SudokuGridModelConstants.getInstance().getSampleNames().iterator();
+    		 while(iter.hasNext())
+    	      {
+    	         String sampleName = iter.next();
+    	         if(sampleName.equals(menuItem.getText())){
+    	        	 sampleMatch = true;
+    	         }
+    	      }
+  	  
+    	  if (sampleMatch ){
+    		 droolsSudokuGridModel = new DroolsSudokuGridModel(SudokuGridModelConstants.getInstance().getSample(menuItem.getText()));
+             sudokuGridView.setModel(droolsSudokuGridModel);
+    	 }
+    	 else     		   
+    	 {
+    		 SudokuGridModelConstants.getInstance().setConstantType( menuItem.getText());
+    			 
+    	     // need to refresh the grid object
+    		 clearMenuBar();
+    		 setMenuBar();
+    	     mainFrame.remove(sudokuGridView);
+    	     run();
+    	 }
          solveButton.setText("Solve");
          solveButton.setEnabled(true);
+         numberOfSolvingPasses = 0;
       }
-      else
-      {
-         //
-      }
    }
 }
Index: main/java/org/drools/examples/sudoku/rules/AbstractCellValue.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/AbstractCellValue.java	(revision 23682)
+++ main/java/org/drools/examples/sudoku/rules/AbstractCellValue.java	(working copy)
@@ -6,7 +6,7 @@
  */
 package org.drools.examples.sudoku.rules;
 
-import org.drools.examples.sudoku.swing.SudokuGridModel;
+import org.drools.examples.sudoku.swing.SudokuGridModelConstants;
 
 /**
  * An abstract class which contains the methods common to both a PossibleCellValue
@@ -67,7 +67,7 @@
     */
    private int deriveZone(int row, int col)
    {
-      return SudokuGridModel.ZONE_LOOKUP[row][col];
+      return SudokuGridModelConstants.getInstance().getZoneLookup()[row][col];
    }
    
    /**
Index: main/java/org/drools/examples/sudoku/rules/BaseCell.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/BaseCell.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/BaseCell.java	(revision 0)
@@ -0,0 +1,31 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.rules;
+
+/**
+ * Represents a single cell location, used to ensure that all possible
+ * cell locations have a determined a cell value as it is possible to 
+ * to eliminate all values for a given row and column in a in error Grid.
+ * 
+ * @author <a href="">Ted Keenan</a>
+ * @version $Revision: 1.1 $
+ */
+public class BaseCell
+   extends AbstractCellValue
+{
+   /**
+    * Uses the constructor on the superclass to construct a new BaseCell
+    * 
+    * @param value the tested value in the cell from 1-9
+    * @param row the row index from 0-8
+    * @param col the column index from 0-8
+    */   
+   public BaseCell(int value, int row, int col)
+   {
+      super(value, row, col);
+   }
+}
Index: main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModel.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModel.java	(revision 23682)
+++ main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModel.java	(working copy)
@@ -8,8 +8,11 @@
 
 import java.util.ArrayList;
 import java.util.HashSet;
+import java.util.Iterator;
 import java.util.List;
 import java.util.Set;
+
+import org.drools.FactException;
 import org.drools.RuleBase;
 import org.drools.StatefulSession;
 import org.drools.event.ObjectInsertedEvent;
@@ -17,16 +20,21 @@
 import org.drools.event.ObjectUpdatedEvent;
 import org.drools.event.WorkingMemoryEventListener;
 import org.drools.examples.sudoku.swing.AbstractSudokuGridModel;
+import org.drools.examples.sudoku.swing.GridModelConstants;
 import org.drools.examples.sudoku.swing.SudokuGridEvent;
-import org.drools.examples.sudoku.swing.SudokuGridModel;
+import org.drools.examples.sudoku.swing.SudokuGridModelInterface;
+import org.drools.examples.sudoku.swing.SudokuGridModelConstants;
 
 /**
  * An implementation of the SudokuGridModel interface which is backed by the Drools engine.
  * <p>
- * Two rule bases are used in this implementation. The first, defined at SUDOKU_SOLVER_DRL 
- * provides a set of rules that attempt to solve a partially completed Sudoku grid. The
- * second, defined at SUDOKU_VALIDATOR_DRL provides a set of rules which can validate 
+ * A single rule base with multiple agenda-groups is used in this implementation. 
+ * The first agenda-group, "BaseTest" provides a set of rules that attempt to solve 
+ * a partially completed Sudoku grid. 
+ * The second agenda-group, "validator" provides a set of rules which can validate  
  * whether the current state of the model represents a valid solution.
+ * Additional agenda-groups provide a guess and test agendas that can be used to identify
+ * possible values that can be eliminated because they end in error.
  * <p>
  * 
  * @author <a href="pbennett@redhat.com">Pete Bennett</a>
@@ -35,25 +43,20 @@
 @SuppressWarnings("unchecked")
 public class DroolsSudokuGridModel
    extends AbstractSudokuGridModel
-   implements SudokuGridModel
+   implements SudokuGridModelInterface 
 {
    /**
     * The location of the DRL file which defines the rule base for solving a Sudoku grid
     */
-   public final static String SUDOKU_SOLVER_DRL = "../sudokuSolver.drl";
+	public final static String SUDOKU_SOLVER_DRL = "../sudokuSolverValidatorWithGuess.drl";
    
-   /**
-    * The location of the DRL file which defines the rule base for validating the content of a Sudoku grid
-    */
-   public final static String SUDOKU_VALIDATOR_DRL = "../sudokuValidator.drl";
-   
    /** A set of AbtractCellValues capturing the current state of the grid */
    private Set<AbstractCellValue> allCellValues 
       = new HashSet<AbstractCellValue>();
    
    /** A index into the AbstractCellValues based on row and column */
    private Set<Integer>[][] cellValuesByRowAndCol 
-      = new HashSet[SudokuGridModel.NUM_ROWS][SudokuGridModel.NUM_COLS];
+      = new HashSet[SudokuGridModelConstants.getInstance().getNumRows()][SudokuGridModelConstants.getInstance().getNumCols()];
 
    /** The solver rule base */
    private RuleBase solverRuleBase;
@@ -63,8 +66,14 @@
 
    /** An inner class implementation listening to working memory events */
    private SudokuWorkingMemoryListener workingMemoryListener = new SudokuWorkingMemoryListener();
-   
+   /** A object to track the state of the model */
+   private DroolsSudokuGridModelState state = new DroolsSudokuGridModelState();
+
    /**
+    * Constants associated with setting up the grid which can be 4x4 or 9x9
+    */
+   protected GridModelConstants modelConstants = SudokuGridModelConstants.getInstance();
+   /**
     * Create a new DroolsSudokuGridModel with an empty grid.
     */
    public DroolsSudokuGridModel()
@@ -107,20 +116,25 @@
       if (solverStatefulSession != null)
       {
          solverStatefulSession.removeEventListener(workingMemoryListener);
+         solverStatefulSession.removeEventListener(state.getWorkingMemoryErrorListener());
       }
       
       solverStatefulSession = solverRuleBase.newStatefulSession();
       solverStatefulSession.addEventListener(workingMemoryListener);
-      
+      solverStatefulSession.addEventListener(state.getWorkingMemoryErrorListener());
+      // set up the facts that will be used in the memory
       for(int row=0; row<cellValues.length; row++)
       {
          for (int col=0; col<cellValues[row].length; col++)
          {
             cellValuesByRowAndCol[row][col] = new HashSet<Integer>();
+        	BaseCell cell = new BaseCell(0, row, col);
+        	addCellValue(cell);
             
+            // check if the cell row is set if not all are possible
             if(cellValues[row][col] == null)
             {
-               for(int value=1; value<10; value++)
+        	   for(int value=1; value<=cellValues.length; value++)
                {
                   PossibleCellValue cellValue = new PossibleCellValue(value, row, col);
                   addCellValue(cellValue);
@@ -129,12 +143,13 @@
             }
             else
             {
+            	// cell is resolved set it up that way
                ResolvedCellValue cellValue = new ResolvedCellValue(cellValues[row][col], row, col);
                addCellValue(cellValue);
             }
          }
       }
-      
+      // set up the memory with the cells
       insertAllCellValues(solverStatefulSession);
       System.out.println("Setting up working memory and inserting all cell value POJOs took "+(System.currentTimeMillis()-startTime)+"ms.");
    }
@@ -171,63 +186,15 @@
     * @return true if the current state represents a completely filled out
     *              and valid Sudoku solution, false otherwise
     */
+   
    public boolean isGridSolved()
    {
-      boolean solved = true;
-      
-      // TODO: move this logic into SUDOKU_VALIDATOR_DRL and out of Java code
-      for(int row=0; row<NUM_ROWS; row++)
-      {
-         for (int col=0; col<NUM_COLS; col++)
-         {
-            if(!isCellResolved(row, col))
-            {
-               System.out.print("("+row+","+col+") has not been resolved but has been narrowed down to ");
-               for (Integer possibleInt : getPossibleCellValues(row, col))
-               {
-                  System.out.print(possibleInt+" ");
-               }
-               System.out.println();
-               solved=false;
-            }
-         }
-      }
-      
-      if (solved)
-      {
-         try
-         {
-            RuleBase validatorRuleBase = DroolsUtil.getInstance().readRuleBase(SUDOKU_VALIDATOR_DRL);
-            
-            StatefulSession validatorStatefulSession = validatorRuleBase.newStatefulSession();
-            List issues = new ArrayList();
-            validatorStatefulSession.setGlobal("issues", issues);
-            insertAllCellValues(validatorStatefulSession);
-            validatorStatefulSession.fireAllRules();
-            
-            if (issues.isEmpty())
-            {
-               System.out.println("Sucessfully Validated Solution");
-            }
-            else
-            {
-               solved = false;
-               for (Object issue : issues)
-               {
-                  System.out.println(issue);
-               }
-            }
-         }
-         catch (Exception ex)
-         {
-            ex.printStackTrace();
-            throw new RuntimeException();
-         }
-      }
-      
-      return solved;
+	   return state.isSolved();
    }
    
+
+
+
    /**
     * Returns the possible values of the cell at a specific 
     * row and column in the Grid.
@@ -240,25 +207,187 @@
     */
    public Set<Integer> getPossibleCellValues(int row, int col)
    {
-      return cellValuesByRowAndCol[row][col];
+	   return cellValuesByRowAndCol[row][col];
    }
-   
    /**
-    * Attempt to solve the Sudoku puzzle from its current state by 
-    * firing all of the rules in SUDOKU_SOLVER_DRL against the 
-    * current state of the Grid then validate if we have solved the 
-    * Grid after this.
+    * Try to solve the grid using just the base solution
     * 
-    * @return true if the state after firing all rules 
-    *              represents a completely filled out
-    *              and valid Sudoku solution, false otherwise 
+    * @return true if the grid can be solved
     */
-   public boolean solve()
-   {
-      solverStatefulSession.fireAllRules();
-      
-      return isGridSolved();
+   public boolean solve(){
+	   try
+       {
+				baseSolution();
+
+				if (state.isInError()) {
+					System.out.println("First Pass with a logical error ");
+					return false;
+				} 
+			
+			if (state.isSolved()) {
+				System.out.println("Sucessfully Validated Solution");
+			} 
+		}
+       catch (Exception ex)
+       {
+          ex.printStackTrace();
+          throw new RuntimeException();
+       }
+	   return state.isSolved() ;
    }
+
+/**
+ * Try to limit one cell to a single possible value so the base test can be used
+ * 
+ * @return true when a cell has been identified that has a single possible value
+ *  
+ * @throws FactException
+ */
+public boolean determineCellsByGuessing() throws FactException {
+	// look to determine the solution to at least one cell
+	int numGuesses = 0;
+	int numErrors = 0;
+	
+	// remove the working memory listener so that it ignores the testing
+	solverStatefulSession.removeEventListener(workingMemoryListener);
+	
+	while((state.isUnSolved()) ){
+		numGuesses = setupGuesses();
+		if (numGuesses == 0 )
+			return false;
+		numErrors = numGuesses ;
+		for (int i = 0; i < numGuesses; i++) {
+			guessTesting();
+			if (state.isSolved())
+			{
+				solverStatefulSession.addEventListener(workingMemoryListener);
+				lastGuessWasRight();
+				break;
+			}				
+			else if (state.isInError()) {
+				numErrors--;
+				solverStatefulSession.addEventListener(workingMemoryListener);
+				lastGuessWasWrong(numErrors);
+				// if there is 1 value left then a cell has been determined
+				// Treat as if it was solved
+				if (numErrors == 1)
+				{
+					state.setIsSolved( DroolsSudokuGridModelState.SUDOKU_STATE_UNSOLVED);
+					return true;
+				}
+				solverStatefulSession.removeEventListener(workingMemoryListener);
+			}
+			else
+			{
+				lastGuessIndeterminate();
+			}
+		}
+	}
+	return true;	
+}
+
+/**
+ * BaseSolution does three things
+ * 1. Test the grid to find resolved cells and remove possible cells  
+ * 2. Remove any errors from previous passes
+ * 3. Validate the current solutions
+ * 
+ * @see DroolsSudokuGridModelState for error listneer
+ * note this uses agenda groups which are put on a stack last to fire goes first
+ *
+ * @throws FactException
+ */
+private void baseSolution() throws FactException {
+	solverStatefulSession.setFocus("Validator");
+	solverStatefulSession.setFocus("ReverseErrors");
+	solverStatefulSession.setFocus("BaseTest");
+  	solverStatefulSession.fireAllRules();
+}
+
+/**
+ * guessTesting does three things
+ * 1. In guess mode test the grid to find resolved cells and remove possible cells  
+ * 2. Remove any errors from previous passes
+ * 3. Validate the current solutions
+ * 
+ * @see DroolsSudokuGridModelState for error listneer
+ * Note the method uses agenda groups which are put on a stack last to fire goes first
+ *
+ * @throws FactException
+ */
+private void guessTesting() {
+	 // Reset solved issues
+	state.setIsSolved(DroolsSudokuGridModelState.SUDOKU_STATE_UNSOLVED);
+	 solverStatefulSession.setFocus("Validator");
+     solverStatefulSession.setFocus("ReverseErrors");
+	 solverStatefulSession.setFocus("GuessTesting");
+	 solverStatefulSession.fireAllRules();
+}
+
+/**
+ * Reverse the last guesses in 2 steps
+ * 1. Reverse the results of the tested guess 
+ * 2. Remove possible rows for the non-correct guess
+ * 
+ * Note the method uses agenda groups which are put on a stack last to fire goes first
+ * 
+ * @throws FactException
+ */
+private void lastGuessWasRight() throws FactException {
+	
+	solverStatefulSession.setFocus("CleanupCorrectGuess");
+	solverStatefulSession.setFocus("ReverseGuess");
+	solverStatefulSession.fireAllRules();
+}
+
+/**
+ * Set the opposite guess from the previous guess which caused an error
+ *  
+ * Note the method uses agenda groups which are put on a stack last to fire goes first
+ * 
+ * @throws FactException
+ */
+private void lastGuessWasWrong(int numErrors) throws FactException {
+	solverStatefulSession.setFocus("GuessSelectionError");
+	if (numErrors == 1)
+	{
+		solverStatefulSession.setFocus("GuessSelectionErrorOneCellRemains");
+	}
+	solverStatefulSession.setFocus("ReverseGuess");
+	solverStatefulSession.fireAllRules();
+	
+}
+/**
+ * The last guess was indeterminate reverse the actions of the guess so that the other
+ * guess can be made 
+ * 
+ * @throws FactException
+ */
+private void lastGuessIndeterminate() throws FactException 
+{
+	solverStatefulSession.setFocus("ReverseGuess");
+	solverStatefulSession.fireAllRules();
+}
+
+/**
+ * Set up the next guess items and return the number of guesses to set up
+ * 
+ * Note the method uses agenda groups which are put on a stack last to fire goes first
+ * 
+ * @return the number of guesses that have been set up
+ * @throws FactException
+ */
+private int setupGuesses() throws FactException {
+	 state.setNumGuesses(0);
+	 solverStatefulSession.setFocus("GuessSelection");
+	 solverStatefulSession.setFocus("GuessSetup");
+	 solverStatefulSession.setFocus("CleanupUnsolved");
+	 solverStatefulSession.setFocus("ReverseErrors");
+     solverStatefulSession.setFocus("ArchiveGuesses");
+     solverStatefulSession.setFocus("BasicRevGuess");
+	 solverStatefulSession.fireAllRules( );
+	 return state.getNumGuesses();
+}
    
    /**
     * Fire the next rule on the agenda and return
@@ -287,7 +416,7 @@
    {
       for (AbstractCellValue cellValue : allCellValues)
       {
-         statefulSession.insert(cellValue);
+          statefulSession.insert(cellValue);
       }
    }
 
@@ -300,7 +429,10 @@
    private void addCellValue(AbstractCellValue cellValue)
    {
       allCellValues.add(cellValue);
-      cellValuesByRowAndCol[cellValue.getRow()][cellValue.getCol()].add(cellValue.getValue());
+      if ( (cellValue instanceof PossibleCellValue)
+	     ||(cellValue instanceof ResolvedCellValue)){
+		        cellValuesByRowAndCol[cellValue.getRow()][cellValue.getCol()].add(cellValue.getValue());
+      }
    }
 
    /**
@@ -312,7 +444,10 @@
    private void removeCellValue(AbstractCellValue cellValue)
    {
       allCellValues.remove(cellValue);
-      cellValuesByRowAndCol[cellValue.getRow()][cellValue.getCol()].remove(cellValue.getValue());
+      if ((cellValue instanceof PossibleCellValue)
+    		  ||(cellValue instanceof ResolvedCellValue)){
+          cellValuesByRowAndCol[cellValue.getRow()][cellValue.getCol()].remove(cellValue.getValue());
+      }
    }
  
 
@@ -340,7 +475,8 @@
    
       public void objectRetracted(ObjectRetractedEvent ev)
       {
-         if (ev.getOldObject() instanceof AbstractCellValue)
+          if ((ev.getOldObject() instanceof PossibleCellValue)
+        		  ||(ev.getOldObject() instanceof ResolvedCellValue))
          {
             AbstractCellValue cellValue = (AbstractCellValue) ev.getOldObject();
             
@@ -355,7 +491,13 @@
          {
             ResolvedCellValue cellValue = (ResolvedCellValue) ev.getObject();
             fireCellUpdatedEvent(new SudokuGridEvent(this, cellValue.getRow(), cellValue.getCol(), cellValue.getValue()));
+   
          }     
       }
    }
+
+public boolean isGridInError()    {
+	   return state.isInError();
 }
+
+}
Index: main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModelState.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModelState.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/DroolsSudokuGridModelState.java	(revision 0)
@@ -0,0 +1,110 @@
+package org.drools.examples.sudoku.rules;
+
+import org.drools.event.ObjectInsertedEvent;
+import org.drools.event.ObjectRetractedEvent;
+import org.drools.event.ObjectUpdatedEvent;
+import org.drools.event.WorkingMemoryEventListener;
+
+public class DroolsSudokuGridModelState {
+	/**
+	    * Mask for cases that haven't been completely solved
+	    */
+	   public final static int SUDOKU_STATE_SOLVED = 0;
+	/**
+	    * Mask for cases that haven't been completely solved
+	    */
+	   public final static int SUDOKU_STATE_UNSOLVED = 1;
+	   /**
+	    * Mask for cases that indicate a bad guess or an unsoluble puzzle
+	    */
+	   public final static int SUDOKU_STATE_ERROR = 2;
+
+	/** An inner class implementation listening to working memory error events */
+	private SudokuWorkingMemoryErrorListener workingMemoryErrorListener;
+	/**
+	    * Flag for tracking errors and the type of error
+	    */
+	private int isSolved;
+	/** 
+	    * Counter for the number of guesses
+	    */
+	private int numGuesses;
+
+	public DroolsSudokuGridModelState() {
+		this.workingMemoryErrorListener = new SudokuWorkingMemoryErrorListener();
+		this.isSolved = SUDOKU_STATE_UNSOLVED ;
+		this.numGuesses = 0;
+	}
+	public boolean isSolved()
+	{
+		return (isSolved == SUDOKU_STATE_SOLVED );
+	}
+	public boolean isUnSolved()
+	{
+		return (isSolved == SUDOKU_STATE_UNSOLVED );
+	}
+
+	public boolean isInError()
+	{
+		return (isSolved == SUDOKU_STATE_ERROR );
+	}
+
+	public WorkingMemoryEventListener getWorkingMemoryErrorListener() {
+		return (WorkingMemoryEventListener) workingMemoryErrorListener;
+	}
+
+/*	public int getIsSolved() {
+		return isSolved;
+	}
+*/
+	public void setIsSolved(int isSolved) {
+		this.isSolved = isSolved;
+	}
+
+	public int getNumGuesses() {
+		return numGuesses;
+	}
+
+	public void setNumGuesses(int numGuesses) {
+		this.numGuesses = numGuesses;
+	}
+	
+	   class SudokuWorkingMemoryErrorListener
+	   implements WorkingMemoryEventListener
+	{
+	   // Check for insert of any error
+	   public void objectInserted(ObjectInsertedEvent ev)
+	   {
+	      if (ev.getObject() instanceof SudokuStatusConflict) 
+	      {
+	    	  setIsSolved(SUDOKU_STATE_ERROR);
+	      }
+	      if ((ev.getObject() instanceof SudokuStatusUnresolved) && (!isInError()))
+	      {
+	    	  setIsSolved( SUDOKU_STATE_UNSOLVED);
+	      }
+	      if(ev.getObject() instanceof GuessedCellValue){
+	    	  setNumGuesses(getNumGuesses() + 1);
+	      }
+	      if(ev.getObject() instanceof SudokuStatusSolved){
+	    	  setIsSolved( SUDOKU_STATE_SOLVED );	    	  
+	      }
+	   }
+
+	      public void objectRetracted(ObjectRetractedEvent ev)
+	      {
+	         if (ev.getOldObject() instanceof GuessedCellValue)
+	         {
+		    	  setNumGuesses(getNumGuesses() - 1);
+	         }     
+	      }
+	   public void objectUpdated(ObjectUpdatedEvent ev)
+	   {
+		      if(ev.getObject() instanceof GuessedCellValue){
+		    	  setNumGuesses(getNumGuesses() + 0);
+		      }
+		   
+	   }
+	}
+
+}
\ No newline at end of file
Index: main/java/org/drools/examples/sudoku/rules/GuessedCellValue.java
===================================================================
--- main/java/org/drools/examples/sudoku/rules/GuessedCellValue.java	(revision 0)
+++ main/java/org/drools/examples/sudoku/rules/GuessedCellValue.java	(revision 0)
@@ -0,0 +1,111 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.drools.examples.sudoku.rules;
+
+/**
+ * Object for tracking the testing of possible cells in a guess and 
+ * test scenario. Each guess is a single, possible value for a given cell,
+ * used when we are guessing what the value for this cell is, only a 
+ * single GuessedCellValue object should be associated with a 
+ * given row and column in a working Grid.
+ * Guessed cells extends RemovedCellBase which has the classes to track which
+ * possible cells were removed to create the guess
+ * 
+ * @author <a href="">Ted Keenan</a>
+ * @version $Revision: 1.1 $
+ */
+public class GuessedCellValue
+   extends RemovedCellBase
+{
+ /**
+  *  Constant for cells that you are planing to test during a guessing cycle
+  */
+   public static int GUESSING_STATUS_PLANED = 0;
+   /**
+    *  Constant for the active cell during a guessing cycle
+    */  
+   public static int GUESSING_STATUS_ACTIVE = 1;
+   /**
+    *  Constant for cells that have been tested during a guessing cycle
+    */  
+   public static int GUESSING_STATUS_TESTED = 2;
+   /**
+    *  Constant for the cell guessed during a previous guessing cycle
+    */  
+   public static int GUESSING_STATUS_PREVIOUS = 4;
+   /**
+    *  state of the cell guessed during the current guessing cycle
+    */  
+   private int state;
+
+   /**
+    * Uses the constructor on the superclass to construct a new GuessedCellValue
+    * from the possible cell being removed
+    * 
+    * @param cellValue possible cell being removed
+    */   
+   public GuessedCellValue(PossibleCellValue cellValue)
+   {
+      super(cellValue);
+      this.state = GUESSING_STATUS_PLANED;
+   }
+   /**
+    * Return the state stored in this cell
+    * 
+    * @return the cell's state
+    */
+   public int getState()
+   {
+      return state;
+   }
+   /**
+    * set the state stored in this cell
+    * 
+    * @param state the new state of the guessed cell
+    */
+   public void setState(int state)
+   {
+      this.state = state;
+   }
+   /**
+    * Return true if the cell is planned for guessing
+    * 
+    * @return state == GUESSING_STATUS_PLANED
+    */
+   public boolean getPlanned()
+   {
+      return (state == GUESSING_STATUS_PLANED);
+   }
+   
+   /**
+    * Return true if the cell is the active guess
+    * 
+    * @return state == GUESSING_STATUS_ACTIVE
+    */
+   public boolean getActive()
+   {
+      return (state == GUESSING_STATUS_ACTIVE);
+   }
+   /**
+    * Return true if the cell has been tested in the current cycle
+    * 
+    * @return state == GUESSING_STATUS_TESTED
+    */
+   public boolean getTested()
+   {
+      return (state == GUESSING_STATUS_TESTED);
+   }
+   /**
+    * Return true if the cell has been tested in a previous cycle
+    * 
+    * @return state == GUESSING_STATUS_PREVIOUS
+    */
+   public boolean getPrevious()
+   {
+      return (state == GUESSING_STATUS_PREVIOUS);
+   }
+}
